//#############################################################################
//#############################################################################
//#### Programma per il controllo di un cubo di led 4x4x4 controllato da  #####
//#### un pic, le cui porta A sono collegate ai piani (z) e le porte B e  #####
//#### C sono collegate ai piani x e y.                                   #####
//#############################################################################
//#############################################################################



//#############################################################################
char x_led, y_led, z_led;   //#################################################
unsigned int map[4], i, n;  //##################DICHIARAZIONE##################
int stato, gioco,tempo, xy; //####################VARIABILI####################
char random_64, random_16,xyz; //##############################################
//#############################################################################





//#############################################################################
//###########################FUNZIONI DI CONVERSIONE###########################
//#############################################################################

//Converte un numero compreso tra 0 e 63 in coordinate (tra 0 e 3).
void conv_xyz(char n)
     {
     z_led=n>>4;
     xy=n & 15;
     y_led=xy>>2;
     x_led=xy & 3;
     }

//Converte le coordinate in un numero compreso tra 0 e 63. (se si vuole
//convertire solo x e y, mettere a zero z).
char conv_n(char x,char y,char z)
     {
     char n;
     xy=(y<<2)+x;
     n=(z<<4)+xy;
     return n;
     }

//Eleva un numero compreso tra 0 e 15
//Eleva un numero compreso tra 0 e 15
unsigned int conv_elevazione (char n)
     {
     unsigned int elev;
     elev=1<<n;
     return elev;
     }

//Questa funzione accende un led date le coordinate.
void acc_led(char x, char y, char z)
     {
     char a, b;
     xy = conv_n(x,y,0);
     porta = 15-conv_elevazione(z);
     a=xy/8;
     b=xy%8;
     if (a)
        {
        portb=conv_elevazione(b);
        portc=0;
        }
     else
        {
        portc=conv_elevazione(b);
        portb=0;
        }
     }

//Questa funzione accende i led di un determinato piano.
void acc_leds(int xy, char z)
     {
     porta =15-conv_elevazione(z);
     portb=xy/256;
     portc=xy%256;

     }

//Questa funzione setta o resetta il bit corrispondente al led.
//Se stato = 1 --> led acceso, se stato = 0 --> led spento.
void cambiaStato(char x, char y, char z, char stato)
     {
     xy = conv_n(x,y,0);
     xy=1<<xy;
     if (stato)        // Deve mettere a 1 il bit corrispondente.
        {      // Esegue l'OR logico tra la maschera e il byte dell'array che
        map[z] |= xy; //equivale a map[index] = map[index] | maschera.
        }
     else        // Deve mettere a 0 il bit corrispondente.
        {        // Esegue l'AND logico tra la maschera e il byte dell'array.
        map[z] &= xy; // quivale a map[index] = map[index] & maschera.
        }
    }

void cambiaStati(int z_0,int z_1,int z_2,int z_3)
     {
     map[0]=z_0;
     map[1]=z_1;
     map[2]=z_2;
     map[3]=z_3;
     }

//Questa funzione restituisce lo stato del led alle coordinate x, y, z.
//Ritorna 0 se led spento, numero diverso da 0 se led acceso.
unsigned int getStato(char x,char y,char z)
         {
         xy=conv_elevazione(conv_n(x,y,0));
         // ottiene la maschera come se dovesse accendere il led.
         return (map[z] & xy);
         }



//Questa funzione controlla quali led sono stati memorizzati come alti (1) e li
//li accende, oppure li spegne dove sono posti a basso (0).

void check_led(int tempo_effetto)
     {
     int tempo;
     for (tempo=0; tempo<tempo_effetto/20; tempo++)
         {
         for (z_led=0; z_led<4; z_led++)
             {
             acc_leds(map[z_led],z_led);
             delay_ms(5);
             }
         }
     }

//Funzione che spegne o accende tutti i led del cubo agendo sull'array.
void reset(char stato)
     {
     for (i = 0; i < 4; i++)
         { if (stato == 0)
           { map[i] = 0; }
           else
               { map[i] = 0xFFFF; }}}

//Funzione che date le coordinate x, y, z, ne cambia lo stato solo se  diverso
//dallo stato dato dalla funzione e se lo cambia, restituisce 1 altrimenti 0.
char cambia_if(char x, char y, char z, char stato)
     {
     int stato_led ;
     stato_led = getStato(x,y,z);       //Siccome getStato ritorna un numero
     if (stato_led)                     //diverso da 0, lo converto in 1 se
        { stato_led = 1; }              //diverso da 0,
     if (stato != stato_led)            //Se lo stato da cambiare  diverso da
        { cambiaStato(x, y, z, stato);  //quello efettivo, lo cambio e
          return 1; }                   //ritorno 1,
     return 0;                          //altrimenti restituisco 0.
     }





//Funzione per generare un seme di partenza per il rand.
unsigned getseme(void)                 //Crea una funzione,
         { return; }                   //che ritorna un numero casuale.

//Genera un numero casuale da 0 a 15 e da 0 a 3.
char random()
     {
     random_64=rand() & 63;
     random_16=rand() & 15;
     return(random_64, random_16);  //Ritorna le due variabili.
     }



//Funzione che accende (stato=1) o spegne (stato=0) tutti i led del cubo
//casualmente.
void fill_empty_led(char stato, char tempo_effetto)
     {
     char led=64, wrong;
     reset(1-stato);
     while (led!=0)
           {
           if (wrong>=5)
              {
              n++;
              if (n==64) n=0;
              }
           else
               {
               random();
               n=random_64;
               }
           conv_xyz(n);
           if (cambia_if(x_led,y_led,z_led,stato))
              {
              check_led(tempo_effetto);
              wrong=0;
              --led;
              }
           else
               {
               wrong++;
               check_led(20);
               }
           if (led==1)
              {
              led=0;
              reset(stato);
              check_led(tempo_effetto);
              }
           }
     }

void pioggia(char volte,int tempo_effetto)
     {
     for (i=0;i<volte;i++)
         {
         random();
         conv_xyz(random_16);
         for (z_led=0;z_led<4;z_led++)
             {
             acc_led(x_led,y_led,z_led);
             vdelay_ms(tempo_effetto);
             }
         vdelay_ms(tempo_effetto/4);
         }
     }

void led_random(int volte,int tempo_effetto)
     {
     for (i=0;i<volte;i++)
         {
         random();
         conv_xyz(random_64);
         acc_led(x_led,y_led,z_led);
         vdelay_ms(tempo_effetto);
         }
     }

//Funzione che accende i led del cubo in base al colore scelto.
//Colore: 1=blu, 2=giallo, 3=verde, 4=rosso.
void colori_led(char colore, int tempo_effetto)
     {
     switch (colore)
            {
            case 1:
            cambiaStati(0x4218,0x8124,0x1842,0x2481);
            break;
            case 2:
            cambiaStati(0x8124,0x1842,0x2481,0x4218);
            break;
            case 3:
            cambiaStati(0x1842,0x2481,0x4218,0x8124);
            break;
            case 4:
            cambiaStati(0x2481,0x4218,0x8124,0x1842);
            break;
            }
    check_led(tempo_effetto);
    }



void effetti_led (int tempo_effetto,char effetto, char dir)
     {
     int piani_x[4]={0x0f,0xf0,0x0f00,0xf000};
     int piani_y[4]={0x1111,0x2222,0x4444,0x8888};
     char s;
     for (i=0;i<4;i++)
         {

         if (dir) s=3-i;
         else s=i;
         for (n=0;n<4;n++)
             {
             switch (effetto)
                    {
                    case 0:
                    map[n]=piani_x[s];
                    break;
                    case 1:
                    map[n]=piani_y[s];
                    break;
                    case 2:
                    map[s]=0xffff;
                    break;

                    }
             }
         check_led(tempo_effetto);
         }
     reset(0);
     }

void rotazione_z (int velocita,char giri,char dir)
     {
     char s;
     for (i=0;i<giri*2;i++)
         {
         for (gioco=0;gioco<6;gioco++)
             {
             if (dir) s=5-gioco;
             else s=gioco;
             switch (s)
                    {
                    case 0:
                    cambiastati(0x1248,0x1248,0x1248,0x1248);
                    break;
                    case 1:
                    cambiastati(0x03C0,0x03C0,0x03C0,0x03C0);
                    break;
                    case 2:
                    cambiastati(0x0C30,0x0C30,0x0C30,0x0C30);
                    break;
                    case 3:
                    cambiastati(0x8421,0x8421,0x8421,0x8421);
                    break;
                    case 4:
                    cambiastati(0x4422,0x4422,0x4422,0x4422);
                    break;
                    case 5:
                    cambiastati(0x2244,0x2244,0x2244,0x2244);
                    break;
                    }
             check_led(velocita/6);
             }
        }
     }
     

void rotazione_x (int velocita,char giri,char dir)
     {
     char s;
     for (i=0;i<giri;i++)
         {
         for (gioco=0;gioco<6;gioco++)
             {
             if (dir) s=5-gioco;
             else s=gioco;
             switch (s)
                    {
                    case 0:
                    cambiastati(0xF000,0x0F00,0xF0,0x0F);
                    break;
                    case 1:
                    cambiastati(0,0xFF00,0xFF,0);
                    break;
                    case 2:
                    cambiastati(0,0xFF,0xFF00,0);
                    break;
                    case 3:
                    cambiastati(0x0F,0xF0,0x0F00,0xF000);
                    break;
                    case 4:
                    cambiastati(0xF0,0xF0,0x0F00,0x0F00);
                    break;
                    case 5:
                    cambiastati(0x0F00,0x0F00,0xF0,0xF0);
                    break;
                    }
             check_led(velocita/6);
             }
        }
     }

 void rotazione_y (int velocita,char giri,char dir)
     {
     char s;
     for (i=0;i<giri;i++)
         {
         for (gioco=0;gioco<6;gioco++)
             {
             if (dir) s=5-gioco;
             else s=gioco;
             switch (s)
                    {
                    case 0:
                    cambiastati(0x8888,0x4444,0x2222,0x1111);
                    break;
                    case 1:
                    cambiastati(0x4444,0x4444,0x2222,0x2222);
                    break;
                    case 2:
                    cambiastati(0x2222,0x2222,0x4444,0x4444);
                    break;
                    case 3:
                    cambiastati(0x1111,0x2222,0x4444,0x8888);
                    break;
                    case 4:
                    cambiastati(0,0x3333,0xCCCC,0x0F00);
                    break;
                    case 5:
                    cambiastati(0,0xCCCC,0x3333,0);
                    break;
                    }
             check_led(velocita/6);
             }
        }
     }

void spirale (int velocita,char giri)
     {
     for (i=0;i<giri*2;i++)
         {
         for (gioco=0;gioco<6;gioco++)
             {

             switch (gioco)
                    {
                    case 5:
                    cambiastati(0x1248,0x03C0,0x0C30,0x8421);
                    break;
                    case 4:
                    cambiastati(0x03C0,0x0C30,0x8421,0x4422);
                    break;
                    case 3:
                    cambiastati(0x0C30,0x8421,0x4422,0x2244);
                    break;
                    case 2:
                    cambiastati(0x8421,0x4422,0x2244,0x1248);
                    break;
                    case 1:
                    cambiastati(0x4422,0x2244,0x1248,0x03C0);
                    break;
                    case 0:
                    cambiastati(0x2244,0x1248,0x03C0,0x0C30);
                    break;
                    }
             check_led(velocita/6);
             }
        }
     }


void cubi_led (int velocita, char giri, char dir)
      {
      char s;
      for (i=0;i<giri;i++)
      {
      for (gioco=0;gioco<16;gioco++)
          {
          if (dir) s=15-gioco;
          else s=gioco;
          switch (s)
                 {
                 case 0:
                 cambiastati(0x33,0x33,0,0);
                 break;
                 case 1:
                 cambiastati(0x66,0x66,0,0);
                 break;
                 case 2:
                 cambiastati(0xCC,0xCC,0,0);
                 break;
                 case 3:
                 cambiastati(0,0xCC,0xCC,0);
                 break;
                 case 4:
                 cambiastati(0,0,0xCC,0xCC);
                 break;
                 case 5:
                 cambiastati(0,0,0xCC0,0xCC0);
                 break;
                 case 6:
                 cambiastati(0,0,0xCC00,0xCC00);
                 break;
                 case 7:
                 cambiastati(0,0xCC00,0xCC00,0);
                 break;
                 case 8:
                 cambiastati(0xCC00,0xCC00,0,0);
                 break;
                 case 9:
                 cambiastati(0x6600,0x6600,0,0);
                 break;
                 case 10:
                 cambiastati(0x3300,0x3300,0,0);
                 break;
                 case 11:
                 cambiastati(0,0x3300,0x3300,0);
                 break;
                 case 12:
                 cambiastati(0,0,0x3300,0x3300);
                 break;
                 case 13:
                 cambiastati(0,0,0x330,0x330);
                 break;
                 case 14:
                 cambiastati(0,0,0x33,0x33);
                 break;
                 case 15:
                 cambiastati(0,0x33,0x33,0);
                 break;
                 }
      check_led(velocita/16);
      }
      }
     }

void semirotazione_led (int velocita, char giri, char dir)
     {
     char s;
     for (i=0;i<giri;i++)
         {
         for (gioco=0;gioco<12;gioco++)
             {
             if (dir) s=11-gioco;
             else s=gioco;
             switch (s)
                    {
                    case 0:
                    cambiastati(0x21,0x21,0x21,0x21);
                    break;
                    case 1:
                    cambiastati(0x22,0x22,0x22,0x22);
                    break;
                    case 2:
                    cambiastati(0x44,0x44,0x44,0x44);
                    break;
                    case 3:
                    cambiastati(0x48,0x48,0x48,0x48);
                    break;
                    case 4:
                    cambiastati(0xC0,0xC0,0xC0,0xC0);
                    break;
                    case 5:
                    cambiastati(0x0C00,0x0C00,0x0C00,0x0C00);
                    break;
                    case 6:
                    cambiastati(0x8400,0x8400,0x8400,0x8400);
                    break;
                    case 7:
                    cambiastati(0x4400,0x4400,0x4400,0x4400);
                    break;
                    case 8:
                    cambiastati(0x2200,0x2200,0x2200,0x2200);
                    break;
                    case 9:
                    cambiastati(0x1200,0x1200,0x1200,0x1200);
                    break;
                    case 10:
                    cambiastati(0x0300,0x0300,0x0300,0x0300);
                    break;
                    case 11:
                    cambiastati(0x30,0x30,0x30,0x30);
                    break;
                    }
             check_led(velocita/12);
             }
        }
     }

void lati_led(char giri, int velocita, char dir)
     {
     char s;
     for (i=0;i<giri;i++)
         {
         for (gioco=0;gioco<16;gioco++)
             {
             if (dir) s=15-gioco;
             else s=gioco;
             switch (s)
                    {
                    case 0:
                    cambiastati(0x0F,0x0F,0x0F,0x0F);
                    break;
                    case 1:
                    cambiastati(0x3C,0x3C,0x3C,0x3C);
                    break;
                    case 2:
                    cambiastati(0x1248,0x1248,0x1248,0x1248);
                    break;
                    case 3:
                    cambiastati(0x4488,0x4488,0x4488,0x4488);
                    break;
                    case 4:
                    cambiastati(0x8888,0x8888,0x8888,0x8888);
                    break;
                    case 5:
                    cambiastati(0x8844,0x8844,0x8844,0x8844);
                    break;
                    case 6:
                    cambiastati(0x8421,0x8421,0x8421,0x8421);
                    break;
                    case 7:
                    cambiastati(0xC300,0xC300,0xC300,0xC300);
                    break;
                    case 8:
                    cambiastati(0xF000,0xF000,0xF000,0xF000);
                    break;
                    case 9:
                    cambiastati(0x3C00,0x3C00,0x3C00,0x3C00);
                    break;
                    case 10:
                    cambiastati(0x1248,0x1248,0x1248,0x1248);
                    break;
                    case 11:
                    cambiastati(0x1122,0x1122,0x1122,0x1122);
                    break;
                    case 12:
                    cambiastati(0x1111,0x1111,0x1111,0x1111);
                    break;
                    case 13:
                    cambiastati(0x2211,0x2211,0x2211,0x2211);
                    break;
                    case 14:
                    cambiastati(0x8421,0x8421,0x8421,0x8421);
                    break;
                    case 15:
                    cambiastati(0xC3,0xC3,0xC3,0xC3);
                    break;

                    }
             check_led(velocita/16);
             }
        }
     }

void giri_led(char giri, int velocita)
     {
     char led_ex[12]={0,1,2,3,7,11,15,14,13,12,8,4};
     char led_int[4]={5,9,10,6};
     char z;
     for (i=0;i<giri/4;i++)
         {
         for (z=0;z<4;z++)
             {
             for (n=0;n<12;n++)
                 {
                 conv_xyz(led_ex[n]);
                 cambiaStato(x_led,y_led,z,1);
                 check_led(velocita/12);
                 reset(0);
                 }
              }
          for (z=4;z!=0;--z)
             {
             for (n=0;n<4;n++)
                 {
                 conv_xyz(led_int[n]);
                 cambiaStato(x_led,y_led,z-1,1);
                 check_led(velocita/12);
                 reset(0);
                 }
              }
          }
     }


void salti_led(int velocita, char volte)
     {
     for (i=0;i<volte;i++)
         {
         for (gioco=0;gioco<10;gioco++)
             {
             switch (gioco)
                    {
                    case 0:
                    cambiaStati(0,0,0,0xffff);
                    break;
                    case 1:
                    cambiaStati(0,0,0x660,0xF99F);
                    break;
                    case 2:
                    cambiaStati(0,0x660,0x6996,0x9009);
                    break;
                    case 3:
                    cambiaStati(0x660,0x6996,0x9009,0);
                    break;
                    case 4:
                    cambiaStati(0x6FF6,0x9009,0,0);
                    break;
                    case 5:
                    cambiaStati(0xffff,0,0,0);
                    break;
                    case 6:
                    cambiaStati(0xF99F,0x660,0,0);
                    break;
                    case 7:
                    cambiaStati(0x9009,0x6996,0x660,0);
                    break;
                    case 8:
                    cambiaStati(0,0x9009,0x6996,0x660);
                    break;
                    case 9:
                    cambiaStati(0,0,0x9009,0x6FF6);
                    break;
                    }
             check_led(velocita/10);
             }
       }
     cambiaStati(0,0,0,0xffff);
     check_led(velocita/10);
     }



void tempesta (int goccie, int tempo)
     {
     char z;
     for (i=0;i<goccie/4;i++)
         {
         for (z=0;z<3;z++)
             {
             random();
             conv_xyz(random_16);
             cambiaStato(x_led,y_led,0,1);
             check_led(tempo/4);
             map[z+1]=map[z];
             map[z]=0;
             check_led(tempo/4);

             }
         }
     }





void main(void)
     {
     trisa=0;
     trisb=0;
     trisc=0;
     porta=0;
     portb=0;
     portc=0;
     srand(getseme());
     
     while (1)
           {
           reset(1);
           check_led(2000);
           reset(0);
           check_led(500);
           reset(1);
           check_led(1000);
           reset(0);
           colori_led(1,1000);
           colori_led(2,1000);
           colori_led(3,1000);
           colori_led(4,1000);
           rotazione_x(1000,4,0);
           rotazione_x(1000,4,1);
           rotazione_y(1000,4,0);
           rotazione_y(1000,4,1);
           rotazione_z(1000,4,0);
           rotazione_z(1000,4,1);
           spirale(800,10);
           cubi_led(1000,10,0);
           cubi_led(1000,10,1);
           salti_led(1000,10);
           semirotazione_led(800,5,0);
           semirotazione_led(800,5,1);
           lati_led(5,2000,0);
           lati_led(5,2000,1);
           giri_led(10,1000);
           pioggia(2,500);
           for (n=1;n<10;n++)
               {
               pioggia(n*2,(11-n)*30);
               }
           pioggia(20,30);
           tempesta(15,500);
           for (n=1;n<10;n++)
               {
               tempesta(n*20,(11-n)*50);
               }
           tempesta(200,30);
           reset(0);
           delay_ms(3000);
           
           }
     }
